package fr.doap.jdb.impl;

import fr.doap.slog.*;

import java.lang.reflect.*;
import java.util.*;

abstract
public class ClassAnalyzer {
	
	abstract public Map<String, PropGetterSetter> analyze(Class<?> aClass);
	
	public boolean isApplicable(Class<?> aClass) { return true; }
	
	static public class FieldCA extends ClassAnalyzer {
		@Override
		public Map<String, PropGetterSetter> analyze(Class<?> aClass) {
			Map<String, PropGetterSetter> lMap = new HashMap<>();
			try {
				Field[] lFields = aClass.getDeclaredFields();
				for (Field iF: lFields) lMap.put(iF.getName(),new PropGetterSetter.FieldGS(iF));
			} catch (Exception aE) { L.t(aE); }
			return lMap;
		}
	}
	
	static public class CollectionCA extends ClassAnalyzer {
		@Override
		public Map<String, PropGetterSetter> analyze(Class<?> aClass) {
			return null;
		}

		@Override
		public boolean isApplicable(Class<?> aClass) {
			return Collection.class.isAssignableFrom(aClass);
		}
	}
}
